import { RequestInit } from 'node-fetch';
import { APITagRequest } from './api-types/APITagRequest';
import { APITagResult } from './api-types/APITagResult';
import { APITag } from './api-types/APITag';
import { APISearchRequest } from './api-types/APISearchRequest';
import { APIBook } from './api-types/APIBook';
import { NineHentaiBook } from './NineHentaiBook';
import { NineHentaiSearch } from './NineHentaiSearch';
export declare type NineHentaiOptions = {
    fetch_options?: RequestInit;
    timeout?: number;
    fetch_tags?: boolean;
    tag_minimum_usage?: number;
};
export declare class NineHentaiAPI {
    private options?;
    private static tags;
    static get_all_tags(): Promise<APITag[]>;
    constructor(options?: NineHentaiOptions);
    private get_fetch_options;
    get_tags(request: APITagRequest): Promise<APITagResult>;
    get_book(book: APIBook): NineHentaiBook;
    get_book(id: number | string): Promise<NineHentaiBook>;
    private fetch_book_details_by_id;
    private get_book_by_id;
    private api_search;
    private get_tags_from_search;
    search(query: string, options?: Partial<APISearchRequest> & {
        auto_tag?: boolean;
    }): Promise<NineHentaiSearch>;
    search(options: Partial<APISearchRequest>): Promise<NineHentaiSearch>;
}
